Redmine - Defect #13781

CJK(Chinese/Japanese/Korean) characters are not shown in PDF on non CJK locales
2013-04-16 12:34 - Toru Haraguchi

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: PDF export Estimated time: 0.00 hour
Target version: 2.6.0

Resolution: Fixed Affected version: 222
Description

When exporting tickets list view to PDF in English personal preference, most of Japanese characters are not shown.
Attached is an example.

Because when in Japanese personal preference those letters are shown, so far no preblem. But this might be annoying for bilingual
(or multilingual) people who prefer English controls of Redmine, but need reading his/her responsible issues written in Japanese.

Related issues:

Related to Redmine - Defect #10681: Export to Persian PDF problem Closed
Related to Redmine - Defect #13575: Graphic characters not exported Closed
Related to Redmine - Feature #17570: use rbpdf gem instead of bundled rfpdf Closed
Related to Redmine - Defect #4787: Gannt to PNG - CJK (Chinese, Japanese and ... Closed 2010-02-10
Has duplicate Redmine - Defect #14701: PDF Export Encoding Closed
Has duplicate Redmine - Defect #1249: I00PDFINNNNOO0O0 Closed 2008-05-17
Has duplicate Redmine - Feature #19282: Export unicode error. Closed

Associated revisions

Revision 13458 - 2014-10-20 06:15 - Toshi MARUYAMA

pdf: define "general_pdf_fontname" at i18n yaml for multilingual environment (#13781)
Contributed by Jun NAITOH.

Revision 13460 - 2014-10-20 08:36 - Toshi MARUYAMA

Merged r13458 from trunk to 2.6-stable (#13781)

pdf: define "general_pdf_fontname" at i18n yaml for multilingual environment.

Contributed by Jun NAITOH.

History

#1 - 2013-04-16 12:48 - Toshi MARUYAMA

- Priority changed from Normal to Low

#2 - 2013-04-16 12:50 - Toshi MARUYAMA

Because embedded FreeSans font does not have glyph.
See #61#note-92.

#3 - 2013-04-16 12:58 - Toshi MARUYAMA

- Subject changed from Japanese characters are not shown in PDF exported ticket list when in English preference to CJK(Chinese/Japanese/Korean)
characters are not shown in PDF exported ticket list when in English preference

#4 - 2013-04-16 13:00 - Toshi MARUYAMA

- Subject changed from CJK(Chinese/Japanese/Korean) characters are not shown in PDF exported ticket list when in English preference to
CJUK(Chinese/Japanese/Korean) characters are not shown in PDF on non CJK locales

#5 - 2013-04-16 15:40 - Filou Centrinov
Related with #10681, #13575
In this and in the related issues the problem is that the included font file does not contain the appropriate glyph.
http://sourceforge.net/projects/tcpdf/files/ provides newer fonts files. The problem is the pdf size increases enormously (#13575).

#6 - 2013-08-16 04:30 - Toshi MARUYAMA
- Has duplicate Defect #14701: PDF Export Encoding added

#7 - 2013-11-17 12:15 - Toshi MARUYAMA
- Has duplicate Defect #1249:000 PDAI000000N0N00 added

#8 - 2014-08-25 04:34 - Maxime Vez

+1 same annoying problem here.

Recently Adobe and Google released an open-source CJK font : http:/blog.typekit.com/2014/07/15/introducing-source-han-sans/
Maybe it can help in solving this issue.

#9 - 2014-08-28 12:35 - Toshi MARUYAMA
- Related to Feature #17570: use rbpdf gem instead of bundled rfpdf added

#10 - 2014-08-28 22:25 - Jun NAITOH
| think that this problem is unsolvable even if it uses a Han Sans font.
It is because the language of a Chinese character is indistinguishable because of Han unification.

I think that fix of this problem requires a PDF font setting function.

Font Setting Plan (Example)
1. Add PDF export options dialog. (like issues CSV export options dialog.)
2. Add PDF font panel for personal account setting.

3. Add PDF font panel for Administration settings.
4. Add default PDF font setting in configuration.yml.

#11 - 2014-08-29 12:25 - Toshi MARUYAMA
- Priority changed from Low to Normal

- Target version set to 2.6.0
I think it is better in configuration.yml because of #4787 consistency.
#12 - 2014-08-29 13:24 - Daniel Felix

Well a user defined setting would be better, or?

A default in the configuration won't help on a multilingual environment. Like people have issues in korean and issues posted in german for example. |
think this would collide and force the german output to break.

#13 - 2014-08-30 09:13 - Jun NAITOH

Daniel Felix wrote:
A default in the configuration won't help on a multilingual environment.
Like people have issues in korean and issues posted in german for example.
| think this would collide and force the german output to break.

Oh... It is important indication.

| consider whether there is any better solution...

#14 - 2014-08-30 10:46 - Toshi MARUYAMA
- Related to Defect #4787: Gannt to PNG - CJK (Chinese, Japanese and Korean) characters appear as ? added

#15 - 2014-10-15 17:12 - Jun NAITOH
- File general_pdf_fontname_r13446.patch added
- File pdf_font_name_r13446.patch added

2025-05-17 2/5


http://sourceforge.net/projects/tcpdf/files/
https://www.redmine.org/issues/13575
http://blog.typekit.com/2014/07/15/introducing-source-han-sans/
http://en.wikipedia.org/wiki/Han_unification
https://www.redmine.org/issues/4787

Maxime Vez wrote:

Recently Adobe and Google released an open-source CJK font : http:/blog.typekit.com/2014/07/15/introducing-source-han-sans/

Maybe it can help in solving this issue.
| tried to use Adobe and Google CJK Font(han-sans), but | couldn't convert from OTF font to TTF font.
rbpdf library can use only a TTF font.
Daniel Felix wrote:

A default in the configuration won't help on a multilingual environment.

Like people have issues in korean and issues posted in german for example.
| think this would collide and force the german output to break.

| wrote patch.

Plan A. (use config/locales/*.yml) : | recommend.

* general_pdf_fontname_r13446.patch locale general_pdf_fontname: Language
ja.yml kozminproregular Japanese
ko.yml hysmyeongjostdmedium Korean (UHC)
th.yml freeserif Thai
vi.yml DejaVuSans Viethamese
zh-TW.yml msungstdlight Traditional Chinese (BIG5)
zh.yml stsongstdlight Simplified Chinese (GB18030)
other yml freesans
etc.. Helvetica

This plan was considered in order to support multilingual environment.
If you use English locale (en.yml) and you want to Japanese characters, so please set to "general_pdf_fontname: kozminproregular" on en.yml.
Plan B. (use configuration.yml) : | don't recommend.
e pdf_font_name_r13446.patch
Configuration of PDF font for non CJKV (and Thai) locale.

| think that this plan has the big influence in multilingual environment.

#16 - 2014-10-18 14:45 - Toshi MARUYAMA

I think Plan A. is better because #8312 supported to switch using font by changing "general_pdf_encoding" at locale yml.

#17 - 2014-10-18 15:48 - Jun NAITOH
Toshi MARUYAMA wrote:

| think Plan A. is better because #8312 supported to switch using font by changing "general_pdf_encoding" at locale yml.

me, too. :)

Plan A : fontname table updated. (add Font type)

locale general_pdf_fontname: (Font type) Language
ja.yml kozminproregular (Non embedded Font (CID Japanese
Font))
ko.yml hysmyeongjostdmedium (Non embedded Font | Korean (UHC)
(CID Font))
th.yml freeserif (embedded Font) Thai
vi.yml DejaVuSans (embedded Font) Vietnamese
zh-TW.yml

msungstdlight (Non embedded Font (CID
Font))

Traditional Chinese (BIG5)

(Non embedded Font(Core Font))

#18 - 2014-10-20 08:40 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Fixed

general_pdf fontname_r13446.patch is committed in trunk r13458 and 2.6-stable r13460, thanks.

#19 - 2014-12-02 07:32 - gank gu
Jun NAITOH wrote:

Maxime Vez wrote:

zh.yml stsongstdlight (Non embedded Font (CID Font)) | Simplified Chinese (GB18030)
other yml freesans (embedded Font)
etc.. courier, helvetica, times, symbol, zapfdingbats

Recently Adobe and Google released an open-source CJK font : http:/blog.typekit.com/2014/07/15/introducing-source-han-sans/

Maybe it can help in solving this issue.

| tried to use Adobe and Google CJK Font(han-sans), but | couldn't convert from OTF font to TTF font.

rbpdf library can use only a TTF font.

Daniel Felix wrote:

A default in the configuration won't help on a multilingual environment.
Like people have issues in korean and issues posted in german for example.
| think this would collide and force the german output to break.

| wrote patch.

Plan A. (use config/locales/*.yml) : | recommend.

e general_pdf_fontname_r13446.patch

locale general_pdf_fontname: Language
ja.yml kozminproregular Japanese
ko.yml hysmyeongjostdmedium Korean (UHC)
th.yml freeserif Thai
vi.yml DejaVuSans Vietnamese
zh-TW.yml msungstdlight Traditional Chinese (BIG5)
zh.yml stsongstdlight Simplified Chinese (GB18030)
other yml freesans
etc.. Helvetica

This plan was considered in order to support multilingual environment.

If you use English locale (en.yml) and you want to Japanese characters, so please set to "general_pdf_fontname: kozminproregular" on en.yml.

Plan B. (use configuration.yml) :

e pdf_font_name_r13446.patch

| don't recommend.

Configuration of PDF font for non CJKV (and Thai) locale.

| think that this plan has the big influence in multilingual environment.

If I'm using english and | want both Traditional Chinese (BIG5) and Simplified Chinese (GB18030), what can | do ? can | specify two font name in

"general_pdf_fontname" ?
#20 - 2014-12-02 10:06 - Toshi MARUYAMA

gank gu wrote:

If I'm using english and | want both Traditional Chinese (BIG5) and Simplified Chinese (GB18030), what can | do ? can | specify two font name in

"general_pdf_fontname" ?

You cannot because of Han unification .

#21 - 2015-03-05 11:39 - Toshi MARUYAMA
- Has duplicate Feature #19282: Export unicode error. added

#22 - 2015-08-09 08:33 - Toshi MARUYAMA
- Related to Defect #20499: Bangla charater of PDF added

#23 - 2015-08-09 08:33 - Toshi MARUYAMA
- Related to deleted (Defect #20499: Bangla charater of PDF)

#24 - 2019-09-10 13:08 - nikunj begda

Hello i found solution for this issue:

1. you need to create mysql database with utf8 parameter.

2. go to /redmine/app/models/user.rb and replace this line and comment the default one
#validates_format_of :login, :with => AA[a-z0-9_\-@\.]"\AV

validates_format_of :login, :with =>
Nla-zA-ZA.. AA™A A AsA AcAvsA AtA-AATA“ASA1A»{5,15}(?:\+[a-zA-ZA...ATA™A A AsA-AcAvuA AtA-AAfA“AsA1A»1{5,15}){0,2)/

or add your language characters before end '/ ' and save the file

now you can login with all the characters.

Files

error_example2.pdf 278 KB 2013-04-16 Toru Haraguchi

general_pdf_fontname_r13446.patch 22 KB 2014-10-15 Jun NAITOH

pdf_font_name_r13446.patch 1.51 KB 2014-10-15 Jun NAITOH
